//
//  Copyright (C) 2000 Denis Lemire <denis@lemire.com>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//                                                                              


#include <iostream>
#include "pwdgenerr.h"

#define PASSWORD_H
#define LOW_ALPHA 1
#define UP_ALPHA 2
#define MIX_ALPHA 3
#define NUMERIC 4
#define LOW_ALPHANUM 5
#define UP_ALPHANUM 6
#define MIX_ALPHANUM 7
#define MISC 8
#define LOW_ALPHA_MISC 9
#define UP_ALPHA_MISC 10
#define MIX_ALPHA_MISC 11
#define NUMERIC_MISC 12
#define LOW_ALPHANUM_MISC 13
#define UP_ALPHANUM_MISC 14
#define MIX_ALPHANUM_MISC 15

#define BOTH 0
#define LEFT 1
#define RIGHT 2
#define ALTERNATE 3

class password
{
  public:
    password ();
    password (int type, int length);
    password (int type, int min, int max);
    void type (int type);
    void length (int length);
    void length (int min, int max);
    void hand (int hand); 
    void pronounceable (bool pronounce);
    char *generate ();
    friend std::ostream &operator << (std::ostream &os, password &a);

  protected:
    void lengthErr () throw (pwdgenerr);
    void seedRandom () throw (pwdgenerr); 
    char getASCII ();
    int checkHand (char randChar, short *counter);
    int checkPronounce (char randChar, short *counter);
    int minLength, maxLength, pwdType, whichHand;
    bool isPronounceable;
    char passwd[21];
};
